//  Simple minded complex number array multiply
#include <stdio.h>
#include <time.h>
#include "complex_new.h"


//routine to initialize an array with data
void init_arr(float real, float img, float offset, float _Complex a[])
{
	int i;

	for (i=0; i< NUM;i++) {
		a[i] = (real*i+offset) + __I__*(img*i+offset);
	}
}

// routine to print out contents of small arrays
void print_arr(char * name, float _Complex array[])
{
	int i;
	
	printf("%s\n", name);
	for (i=0;i<NUM;i++){
		printf("(%g, %g)\t",crealf(array[i]),cimagf(array[i]));
	}
	printf("\n");
}


main()
{
	clock_t start, stop;
	int num;

//	_MM_SET_FLUSH_ZERO_MODE(_MM_FLUSH_ZERO_ON);
// initialize the arrays with data
	init_arr(3,-2,1,a);
	init_arr(-2,1,3,b);

	//start timing the matrix multiply code
	printf("NUM:%d\n",NUM);
	start = clock();
	multiply_d(a,b,c);
	stop = clock();

// print simple test case of data to be sure multiplication is correct
	if (NUM < 5) {
		print_arr("a", a);
		print_arr("b", b);
		print_arr("c", c);
	}

// print elapsed time
	printf("Elapsed time = %lf seconds\n",
    		((double)(stop - start)) / CLOCKS_PER_SEC);

//	_MM_SET_FLUSH_ZERO_MODE(_MM_FLUSH_ZERO_OFF);
}

