//  Simple minded complex number array multiply
#include <stdio.h>
#include <time.h>
#include "complex.h"

void multiply_d(struct Complex a[], struct Complex b[], struct Complex c[]);


struct Complex a[NUM], b[NUM], c[NUM];

//routine to initialize an array with data
void init_arr(float real, float img, float offset, struct Complex a[])
{
	int i;

	for (i=0; i< NUM;i++) {
		a[i].r = real*i+offset;
		a[i].i = img*i+offset;
	}
}

// routine to print out contents of small arrays
void print_arr(char * name, struct Complex array[])
{
	int i;
	
	printf("%s\n", name);
	for (i=0;i<NUM;i++){
		printf("(%g, %g)\t",array[i].r,array[i].i);
	}
	printf("\n");
}


main()
{
	clock_t start, stop;
	int num;

//	_MM_SET_FLUSH_ZERO_MODE(_MM_FLUSH_ZERO_ON);
// initialize the arrays with data
	init_arr(3,-2,1,a);
	init_arr(-2,1,3,b);

	//start timing the matrix multiply code
	printf("NUM:%d\n",NUM);
	start = clock();
	multiply_d(a,b,c);
	stop = clock();

// print simple test case of data to be sure multiplication is correct
	if (NUM < 5) {
		print_arr("a", a);
		print_arr("b", b);
		print_arr("c", c);
	}

// print elapsed time
	printf("Elapsed time = %lf seconds\n",
    		((double)(stop - start)) / CLOCKS_PER_SEC);

//	_MM_SET_FLUSH_ZERO_MODE(_MM_FLUSH_ZERO_OFF);
}

