#include "square.h"
float trap_int(float y, float x0, float xn, int nx, float xp, float yp) {

float x, h, sumx;
int i;
#ifdef RF
  h = (xn-x0) / nx;
  sumx = 0.5*( func(x0,y,xp,yp) + func(xn,y,xp,yp) );

  for (i=1;i<nx;i++) {
    x = x0 + i*h;
    sumx = sumx + func(x,y,xp,yp);
  }
  sumx = sumx * h;

  return sumx;
#else
  h = (xn-x0) / nx;
  sumx = 0.5*( *func(x0,y,xp,yp) + *func(xn,y,xp,yp) );

  for (i=1;i<nx;i++) {
    x = x0 + i*h;
    sumx = sumx + *func(x,y,xp,yp);
  }
  sumx = sumx * h;

  return sumx;
#endif
}
